:: Culmus MikTeX Installer 0.2.2
:: Created by Iddo Samet 2014-10-14
::
:: Version history:
:: v0.2   - 27/7/2008  - Initial release
:: v0.2.1 - 6/10/2009  - Added support for MikTeX 2.8
::                     - Added support for Windows Vista and Windows 7 in SFX
:: v0.2.2 - 14/10/2014 - Support for new babel-hebrew package

@echo off
echo ===========================================================
echo :: Culmus MikTeX Installer 0.2.2
echo :: Created by Iddo Samet 2014-10-14
echo :: http://www.ma.huji.ac.il/~sameti/tex/culmusmiktex.html
echo ===========================================================

setlocal
echo Searching for MikTeX installation.
echo Trying to run initexmf...
(initexmf --report) >tmp 2>&1
if not "%errorlevel%"=="0" goto :noinitexmf

echo Found initexmf.
set initexmf=initexmf
find "CommonData" <tmp >tmp2
if not "%errorlevel%"=="0" echo Could not parse initexmf output. & goto :noinitexmf
set /p desttmp= <tmp2 >nul
set dest=%desttmp:~12%
del /q tmp?
goto :install

:noinitexmf
echo Could not find initexmf in path. Searching for MikTeX directories.
for %%i in (5 6 7 8 9) do (
	if exist "%programfiles%\miktex 2.%%i\miktex\bin\initexmf.exe" (
		set subver=%%i
		set initexmf=%programfiles%\miktex 2.%%i\miktex\bin\initexmf.exe
	)
	if exist "%allusersprofile%\application data\miktex\2.%%i" set subver=%%i
)
if "%subver%"=="" goto :notfound

set dest=%allusersprofile%\application data\miktex\2.%subver%
echo Found MikTeX version 2.%subver%.
goto :install 

:notfound
set dest=%userprofile%\culmus
echo MikTeX not found. 
echo ---------------------------------------------------------------  
echo Files will be copied to default location:
echo    %dest%
echo You can manually copy files from there to the correct location.
echo After copying them you will need to run 'initexmf -u' and 'initexmf --mkmaps'.
goto :copy

:install
echo ---------------------------------------------------------------  
echo Target directory is:
echo    %dest%

pushd "%dest%"

echo Erasing old Culmus installaion.
del /q dvips\config\culmus*.* 2>nul
del /q dvips\base\culmus*.* 2>nul
del fontname\culmus.map 2>nul
del /q fonts\afm\culmus\*.* 2>nul
del /q fonts\afm\public\culmus\*.* 2>nul
del /q fonts\fd\he8*.* 2>nul
del /q fonts\tfm\culmus\*.* 2>nul
del /q fonts\tfm\public\culmus\*.* 2>nul
del /q fonts\type1\culmus\*.* 2>nul
del /q fonts\type1\public\culmus\*.* 2>nul
del /q fonts\vf\culmus\*.* 2>nul
del /q fonts\vf\public\culmus\*.* 2>nul
del /q /s fonts\pk\modeless\culmus\*.* >nul 2>&1
del /q /s fonts\pk\modeless\public\culmus\*.* >nul 2>&1
del /q tex\generic\babel\*.* 2>nul
del /q tex\latex\culmus\*.* 2>nul

rmdir fontname 2>nul
rmdir fonts\afm\culmus 2>nul
rmdir fonts\tfm\culmus 2>nul
rmdir fonts\type1\culmus 2>nul
rmdir fonts\vf\culmus 2>nul
rmdir fonts\afm\public\culmus 2>nul
rmdir fonts\tfm\public\culmus 2>nul
rmdir fonts\type1\public\culmus 2>nul
rmdir fonts\vf\public\culmus 2>nul

popd

if exist "%dest%\miktex\config\updmap.cfg" goto :updatemap
goto :copy

:copy
echo Copying files...
mkdir "%dest%" 2>nul
xcopy *.* "%dest%" /q /y /s
del "%dest%\culmusmiktex.bat"
echo ---------------------------------------------------------------  
if "%initexmf%"=="" goto :noinitexmf
goto :runinitexmf

:runinitexmf
"%initexmf%" --admin >nul 2>&1
if not "%errorlevel%"=="0" goto :noadmin
echo Updating MikTeX file name database: initexmf --admin -u
"%initexmf%" --admin -u
echo Updating MikTeX map files: initexmf --admin --mkmaps
echo (this may take a few minutes)
"%initexmf%" --admin --mkmaps

:noadmin
echo Updating MikTeX file name database: initexmf -u
"%initexmf%" -u
echo Updating MikTeX map files: initexmf --mkmaps
echo (this may take a few minutes)
"%initexmf%" --mkmaps
echo ---------------------------------------------------------------  
echo Done!
echo ---------------------------------------------------------------  
goto :end

:noinitexmf 
echo File installation done, but MikTeX was not updated.
echo When you find initexmf you should run the following:
echo initexmf -u
echo initexmf --mkmaps
goto :end

:updatemap
find /i /v "culmus" <"%dest%\miktex\config\updmap.cfg" >updmap.tmp
type miktex\config\updmap.cfg >>updmap.tmp
copy updmap.tmp miktex\config\updmap.cfg >nul
del updmap.tmp
goto :copy

:end
endlocal
pause